#!/usr/bin/perl

use Time::gmtime;

require "timelocal.pl";

# A list of all your forums, in order
# Rename forum1, forum2, etc. to the name you want the forum to have in the YaBB system
# For example, forum1 can be renamed to "welcome"
# Also, if you've deleted any forums from UBB (i.e., you have a Forum1 and a Forum3
# but have deleted Forum2), you'll need to put in a dummy folder in its stead
@forumFileNames = qw ( forum1
  forum2
  forum3
  forum4
);

for($forumIndex = 0; $forumIndex < 41; $forumIndex++) {
	$forumName = $forumFileNames[$forumIndex];
	$currentFolder = "Forum" . int($forumIndex+1);
	unless (-e "$currentFolder/lastnumber.file") { next; }
	open(FILE, "$currentFolder/lastnumber.file") || die "Couldn't open $currentFolder/lastnumber.file";
	$lastNumberIndex = $numThread = $numPost = $lastThreadNumber = 0;
	while(<FILE>) {
		chomp;
		$lastThreadNumber = int($_) if($lastNumberIndex == 0);
		$numThread = $_ if($lastNumberIndex == 1);
		$numPost = $_ if ($lastNumberIndex == 2);
		$lastNumberIndex++;
	}
	close(FILE);
	
	for($threadIndex = 1; $threadIndex <= $lastThreadNumber; $threadIndex++) {
		next unless (-e "$currentFolder/" . numberToFile($threadIndex));
		open(FILE, "$currentFolder/" . numberToFile($threadIndex)) || die "Couldn't open $currentFolder/" . numberToFile($threadIndex);
		$firstLine = <FILE>;
		chomp $firstLine;
		@threadData = split(/\|\|/, $firstLine);
		$numReply = noPipeline($threadData[2]);
		$starterUserName = noPipeline($threadData[3]);
		$subject = noPipeline($threadData[4]);
		$starterDisplayName = fixGuestName(noPipeline($threadData[8]));
		
		$beenThroughOnce = 0;
		while(<FILE>) {
			chomp;
			@postData = split(/\|\|/);		
			$postUserName = noPipeline($postData[2]);
			$postDate = noPipeline($postData[3]);
			$postTime = noPipeline($postData[4]);
			$niceDateTime = pacificTime($postDate, $postTime);
			unless ($beenThroughOnce) {
				$threadName = stringToTime($niceDateTime);
				if (-e "Messages/$threadName.txt") { while (-e "Messages/$threadName.txt") { $threadName++; } }
			}
			$postMessage = cleanMessage($postData[6]);
			$postIP = noPipeline($postData[7]);
			$smiley = noPipeline(getSmiley($postData[9]));
			$postDisplayName = fixGuestName(noPipeline($postData[10]));
			$postSubject = $subject;
			$postSubject = "Re: $subject" if($beenThroughOnce);
			
			open(OUTFILE,">>Messages/$threadName.txt");
			print OUTFILE "$postSubject|$postDisplayName||$niceDateTime|";
			if($postUserName =~ m#&lt;(.+)&gt;#) { print OUTFILE "Guest"; }
			else { print OUTFILE fixUserName($postUserName); }
			print OUTFILE "|$smiley|0|$postIP|$postMessage||\n";
			close(OUTFILE);
			
			unless($beenThroughOnce) {
				open(OUTFILE,">>Boards/$forumName.txt");
				print OUTFILE "$threadName|$subject|$starterDisplayName||$niceDateTime|$numReply|";
				if($starterUserName =~ m#&lt;(.+)&gt;#) { print OUTFILE "Guest"; }
				else { print OUTFILE fixUserName($starterUserName); }
				print OUTFILE "|$smiley|0\n";
				close(OUTFILE);
			}
			$beenThroughOnce = 1;
		}
		close(FILE);
		open(OUTFILE,">>Messages/$threadName.data");
		print OUTFILE "1|" . fixUserName($postUserName);
	}
	open(OUTFILE,">>Boards/$forumName.ttl");
	print OUTFILE "$numThread|$numPost|$niceDateTime|" . fixUserName($postUserName);
	close(OUTFILE);
}

sub numberToFile {
	my ($original, $temp);
	$original = $temp = $_[0];
	$num_digits = 0;
	for(;;) {
		$num_digits++;
		$temp = int($temp/10);
		if($temp <= 0) { last; }
	}
	return ("0" x (6-int($num_digits++))) . $original . "\.cgi";
}

sub fixGuestName {
	my $temp;
	$temp = $_[0];
	$temp =~ s#&lt;(.+)&gt;#\1#g;
	return $temp;
}

sub fixUserName {
 	my ($temp);
 	$temp = $_[0];
	if($temp =~ m#&lt;(.+)&gt;#) {	# Is a Guest
		$temp =~ s/&lt;(.+)&gt;/\1/g;
		return "Guest-$temp";
	}
	else {
		$temp =~ s/ /_/g;
		$temp =~ s/\W//g;
		return "\L$temp";
	}
}

sub pacificTime {
	my ($date, $time, $month, $day, $year, $hour, $minute, $amPm);
	$date = $_[0];
	$time = $_[1];
	
	($month, $day, $year) = split(/\W/, $date);
	($hour, $minute, $amPm) = split(/\W/, $time);
	$year = substr($year, 2, 2);
	
	$hour += 12 if ($amPm eq 'PM');
	
	$hour -= 8;
	if($hour < 0) {
		$hour += 24;
		$day--;
	}
	if($day <= 0) {
		$month--;
		$day += getNumDays($month);
	}
	if($month <= 0) {
		$month += 12;
		$year--;
	}

	$month = "0" . int($month) if($month < 10);
	$day = "0" . int($day) if($day < 10);
	$year = "0" . int($year) if($year < 10);
	$hour = "0" . int($hour) if($hour < 10);
	$minute = "0" . int($minute) if($minute < 10);
	
	return "$month/$day/$year at $hour:$minute";
}

sub getNumDays {
	my $temp;
	$temp = int($_[0]);
	if($temp == 2) { return 28; }
	elsif($temp == 4 || $temp == 6 || $temp == 9 || $temp == 11) { return 30; }
	else { return 31; }
}
	

sub stringToTime {
	unless( $_[0] ) { return 0; }
	my( $adate, $atime ) = split(m~ $txt{'107'} ~, $_[0]);
	my( $amonth, $aday, $ayear ) = split(m~/~, $adate);
	my( $ahour, $amin, $asec ) = split (m~:~, $atime);
	$asec = int($asec) || 0;
	$amin = int($amin) || 0;
	$ahour = int($ahour) || 0;
	$ayear = int($ayear) || 0;
	$amonth = int($amonth) || 0;
	$aday = int($aday) || 0;
	$ayear += 100;
	if( $amonth < 1 ) { $amonth = 0; }
	elsif( $amonth > 12 ) { $amonth = 11; }
	else { --$amonth; }
	if( $aday < 1 ) { $aday = 1; }
	elsif( $aday > 31 ) { $aday = 31; }
	return timelocal($asec, $amin, $ahour, $aday, $amonth, $ayear);
}

sub getSmiley {
	if($_[0] == 3) { return "lamp"; }
	elsif($_[0] == 4) { return "exclamation"; }
	elsif($_[0] == 5) { return "question"; }
	elsif($_[0] == 6) { return "laugh"; }
	elsif($_[0] == 7) { return "smiley"; }
	elsif($_[0] == 8) { return "angry"; }
	elsif($_[0] == 9) { return "sad"; }
	elsif($_[0] == 10) { return "cheesy"; }
	elsif($_[0] == 12) { return "wink"; }
	elsif($_[0] == 13) { return "thumbdown"; }
	elsif($_[0] == 14) { return "thumbup"; }
	else { return "xx"; }
}

sub cleanMessage {
	my $temp;
	$temp = $_[0];
	$temp =~ s#<(b|i|u|s)>#[\1]#g;
	$temp =~ s#</(b|i|u|s)>#[/\1]#g;
	$temp =~ s#<IMG SRC="smile.gif" border="0">#:)#g;
	$temp =~ s#<IMG SRC="frown.gif" border="0">#:(#g;
	$temp =~ s#<IMG SRC="redface.gif" border="0">#:o#g;
	$temp =~ s#<IMG SRC="biggrin.gif" border="0">#:D#g;
	$temp =~ s#<IMG SRC="wink.gif" border="0">#;)#g;
	$temp =~ s#<IMG SRC="tongue.gif" border="0">#:p#g;
	$temp =~ s#<IMG SRC="cool.gif" border="0">#8)#g;
	$temp =~ s#<IMG SRC="rollseyes.gif" border="0">#::)#g;
	$temp =~ s#<IMG SRC="mad.gif" border="0">#>:)#g;
	$temp =~ s#<IMG SRC="eek.gif" border="0">#:o#g;
	$temp =~ s#<IMG SRC="confused.gif" border="0">#???#g;
	$temp =~ s#<IMG(.+)">##g;
	$temp =~ s#<BLOCKQUOTE>(.+)<HR>#[quote]#g;
	$temp =~ s#<BLOCKQUOTE>(.+):<BR><B>#[quote]#g;
	$temp =~ s#</B><HR></BLOCKQUOTE>#[/quote]#g;
	$temp =~ s#<HR>#[hr]#g;
	$temp =~ s!<A HREF="([^\"]+)" TARGET=_blank>([^\<]+)</A>!\[url=\1\]\2\[\/url\]!g;
	$temp =~ s!<BR>!<br>!g;
	$temp =~ s!<(P|p)>!<br><br>!g;

	return noPipeline($temp);
}

sub noPipeline {
	my $temp;
	$temp = $_[0];
	$temp =~ s#\|#i#g;
	
	return $temp;
}